#include "Keyboard.h"
#include "DFRobot_BNO055.h"
#include "Wire.h"

typedef DFRobot_BNO055_IIC    BNO;    // ******** use abbreviations instead of full names ********

BNO   bno(&Wire, 0x28);    // input TwoWire interface and IIC address
BNO::sEulAnalog_t   sEul;
BNO::sAxisAnalog_t   sAxis;
BNO::eAxis_t eAxis_t1;

void printLastOperateStatus(BNO::eStatus_t eStatus)
{
  switch(eStatus) {
  case BNO::eStatusOK:    Serial.println("everything ok"); break;
  case BNO::eStatusErr:   Serial.println("unknow error"); break;
  case BNO::eStatusErrDeviceNotDetect:    Serial.println("device not detected"); break;
  case BNO::eStatusErrDeviceReadyTimeOut: Serial.println("device ready time out"); break;
  case BNO::eStatusErrDeviceStatus:       Serial.println("device internal status error"); break;
  default: Serial.println("unknow status"); break;
  }
}

void setup()
{
  Serial.begin(115200);
  pinMode(4, INPUT_PULLUP);
  //pinMode(LED_BUILTIN, OUTPUT);
  Keyboard.begin();
  bno.reset();
  while(bno.begin() != BNO::eStatusOK) {
    Serial.println("bno begin faild");
    printLastOperateStatus(bno.lastOperateStatus);
    delay(2000);
  }
  Serial.println("bno begin success");
}

void loop()
{
  while(digitalRead(4)){

  sEul = bno.getEul();
//  Serial.print("pitch:");
//  Serial.print(sEul.pitch, 3);
//  Serial.print(" ");
//  Serial.print("roll:");
//  Serial.print(sEul.roll, 3);
//  Serial.print(" ");
//  Serial.print("yaw:");
//  Serial.print(sEul.head, 3);
//  Serial.println(" ");

  sAxis = bno.getAxis(BNO::eAxisAcc);
//  Serial.print("x:");
//  Serial.print(sAxis.x, 3);
//  Serial.print(" ");
//  Serial.print("y:");
//  Serial.print(sAxis.y, 3);
//  Serial.print(" ");
//  Serial.print("z:");
//  Serial.print(sAxis.z, 3);
//  Serial.println(" ");
  delay(100);

  if(sEul.pitch<-120){
    //往左走
   Keyboard.press('D');
   delay(200);
   Keyboard.releaseAll();
  }
  else if(sEul.pitch>-60){
    //往右走
    Keyboard.press('A');
    delay(200);
    Keyboard.releaseAll();
  }
  
  if(sEul.roll>10){
    //往上走
    Keyboard.press('W');
    delay(200);
    Keyboard.releaseAll();
  }
  else if(sEul.roll<-10){
    //往下走
    Keyboard.press('S');
    delay(200);
    Keyboard.releaseAll();
  }
  
  if((sAxis.x>500)&&(sAxis.y>500)){
    //往前捅，杀人，Q键
    Keyboard.press('Q');
    delay(200);
    Keyboard.releaseAll();
  }
  else if((sAxis.x>1000)&&(sAxis.y<200)){
    //往后拉
    delay(200);
  }
  else if((sAxis.y>1000)&&(sAxis.z<1000)){
    //往左推
    delay(200);
  }
  else if((sAxis.y>1000)&&(sAxis.z<-1000)){
    //往右推
    delay(200);
  }
  
  }
}
